#!/bin/sh
. common

remove()
{
for i in `./hex2env "${QS}" | grep "^remove"`
do
echo "i=$i" >> /tmp/a.txt
  ruleidx=`echo "${i}"|cut -c7-|cut -d";" -f1`
  grep -v "^forwardrule=${ruleidx};" ${CFG} > ${TMP}
  mv ${TMP} ${CFG} 
done
}

select_if()
{
echo "<td><select name=add$1>"
echo "<option value=any>any</option>"
for i in `grep "^if=" ${CFG}|cut -d"=" -f2`
do
  echo "<option value=${i}>${i}</option>"
done
echo "</select></td>"
}

select_addr()
{
echo "<td><select name=add$1>"
echo "<option selected value=\"anywhere\">anywhere</option>"
for i in `grep "^addr=" ${CFG}|cut -d"=" -f2|cut -d";" -f1`
do
  echo "<option value=${i}>${i}</option>"
done
echo "</select></td>"
}

header "Forward Rules"

QS=`cat -`
remove
addline forwardrule `./hex2env "${QS}" | grep "^add"`

echo "<table border=1><tr><th>Remove?</th><th>Index</th><th>Application</th>"
echo "<th>Packet Source</th><th>Packet Destination</th><th>IP Source</th>"
echo "<th>IP Destination</th><th>Action</th><th>Advanced</th></tr>"
echo "<form action=\"./forward.cgi\" method=post>"
ruleidx=0
for i in `grep "^forwardrule=" ${CFG} |cut -d"=" -f2-`
do 
  #ruleidx=`echo $i|cut -d";" -f1`
  ruleidx=`expr ${ruleidx} + 1`
  app=`echo $i|cut -d";" -f2`
  if_in=`echo $i|cut -d";" -f3`
  if_out=`echo $i|cut -d";" -f4`
  client=`echo $i|cut -d";" -f5`
  server=`echo $i|cut -d";" -f6`
  action=`echo $i|cut -d";" -f7`
  echo "<tr><td><input type=checkbox name=\"remove${i}\"></td>"
  echo "<td>${ruleidx}</td>"
  echo "<td>${app}</td>"
  echo "<td>${if_in}</td>"
  echo "<td>${if_out}</td>"
  echo "<td>${client}</td>"
  echo "<td>${server}</td>"
  echo "<td>${action}</td>"
  echo "<td><a target=\"rule_${ruleidx}\" href=\"./rule_adv.cgi?${ruleidx}\">Advanced</a></td>"
  echo "</tr>"
done
echo "<tr><td>"
echo "<B>New:</B></td>"
ruleidx=`expr ${ruleidx} + 1`
echo "<td><input type=hidden name=addruleidx value=${ruleidx}><input type=checkbox name=\"addline\"></td>"
echo "<td><select name=addapp>"
for i in `grep "^app=" ${CFG}|cut -d"=" -f2|cut -d";" -f1`
do
  echo "<option value=${i}>${i}</option>"
done
echo "</select></td>"
select_if 
select_if 
select_addr client
select_addr server
echo "<td><select name=addaction><option selected value=ACCEPT>ACCEPT</option>"
echo "<option value=REJECT>REJECT</option>"
echo "<option value=DROP>DROP</option>"
echo "<option value=REDIRECT>REDIRECT</option>"
echo "<option value=NAT>NAT</option></td>"
echo "</tr>"
echo "<tr><td><input type=submit value=\"Confirm\"></td><td><input type=reset value="Reset"></td></tr>"
echo "</table>"
EOHTML

#rm -f ${TMP}
footer
